<script lang="ts">
	import { Edit2Icon, Trash2Icon } from 'svelte-feather-icons';
	import Button from '../../../../../components/Button.svelte';
	import type { Category, ProductFB } from '../type';
	import { deleteDoc, doc } from 'firebase/firestore';
	import { deleteObject, ref } from 'firebase/storage';
	import { db, storage } from '$lib/firebase/firebase';
	import { createEventDispatcher } from 'svelte';
	import EditProduct from './EditProduct.svelte';

	export let product: ProductFB;
	export let category: Category;

	const dispatch = createEventDispatcher();

	const deleteProduct = async (product: ProductFB) => {
		await deleteDoc(doc(db, 'products', product.id));
		await deleteObject(ref(storage, 'products/' + product.imgName));
		dispatch('refresh');
	};

	let showEditProduit = false;

	let editProductRequest: ProductFB = {
		id: '',
		name: '',
		categoryId: '',
		imgUrl: '',
		imgName: ''
	};
</script>

<div class="flex justify-between items-center">
	<div class="flex flex-row items-center gap-2 h-full">
		<img src={product.imgUrl} alt="" class="aspect-square w-20" />
		<span> {product.name}</span>
		<!-- <span>Description: {product.description}</span> -->
	</div>
	<div class="flex gap-2">
		<Button
			type="secondary"
			on:click={() => {
				editProductRequest = {
					id: product.id,
					name: product.name,
					categoryId: product.categoryId,
					imgUrl: product.imgUrl,
					imgName: product.imgName
				};
				showEditProduit = true;
			}}
		>
			<Edit2Icon />
		</Button>
		<Button type="error" on:dblclick={() => deleteProduct(product)}>
			<Trash2Icon />
		</Button>
	</div>
</div>
<EditProduct
	bind:show={showEditProduit}
	on:add
	categoryId={category.id}
	newProduct={editProductRequest}
/>

<div class="border-b border-primary-700 w-full" />
